%{
#include <stdio.h>

int w = 0;
int c = 0;
int l = 0;
%}

NODELIM         [^ ,;:.\n\(\)]
SPACE           [ \t\n]

%%
                                    { w = 0; c = 0; l = 0; }
{NODELIM}+                          { w++; c += strlen(yytext); }
{NODELIM}+"-"\n{SPACE}*{NODELIM}+   { 
                                        w++; printf("%s\n", yytext);
                                    }
.                                   { c++; }
\n                                  { c++; l++; }

%%

int main(int argc, char *argv[]) {
    if (argc > 1) {
        /* Read input from a file instead of standard input */
        if (freopen(argv[1], "r", stdin) == NULL) {
            perror("Cannot open input file");
            exit(1);
        }
    }
    yylex();
    printf("Number of lines = %d, words = %d, characters = %d\n", l, w, c);
    return 0;
}

int yywrap() {
    return 1;
}
